<?php

namespace App\Models;

use App\Entities\UserEntity;

class UserModel extends CommonModel
{
    const TABLE = "user";
    const PK = "uid";
    const TITLE = "name";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = UserEntity::class;
    protected $allowedFields = [
        "id",
        "passwd",
        "name",
        "email",
        "mobile",
        "role",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "id":
                $rule = "required|trim|min_length[4]|max_length[20]";
                $rule .= in_array($action, ["create", "create_form"]) ? "|is_unique[{$this->table}.{$field}]" : "";
                break;
            case "passwd":
                $rule = in_array($action, ["create", "create_form"]) ? "required|trim|string" : "permit_empty|trim|string";
                break;
            case "confirmpassword":
                $rule = in_array($action, ["create", "create_form"]) ? "required|trim|string|matches[passwd]" : "permit_empty|trim|string|matches[passwd]";
                break;
            case "email":
                $rule = "required|trim|valid_email";
                $rule .= in_array($action, ["create", "create_form"]) ? "|is_unique[{$this->table}.{$field}]" : "";
                break;
            case "role":
                $rule  = "required|trim|string";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
    protected function convert_process(string $action, string $field, array $formDatas): mixed
    {
        switch ($field) {
            case "passwd":
                $convertedData = password_hash($formDatas[$field], PASSWORD_DEFAULT);
                break;
            case "confirmpassword":
                $convertedData = password_hash($formDatas[$field], PASSWORD_DEFAULT);
                break;
            default:
                $convertedData = parent::convert_process($action, $field, $formDatas);
                break;
        }
        return $convertedData;
    }
}
